#include <windows.h>
#include "..\..\CGTShare.h"
#include "share.h"


extern "C" __declspec(dllexport) int buildGetParamsProc(TBuildParams &params)
{
  params.flags = CGMP_RUN;
  return(CG_SUCCESS);
}

extern "C" __declspec(dllexport) int buildMakePrj(TBuildMakePrjRec &params)
{
  TFileStream f(string((PChar)params.prjFilename), 0);
  f.Write(params.result, strlen((PChar)params.result));
  return CG_SUCCESS;
}

extern "C" __declspec(dllexport) int buildCompliteProc(TBuildCompliteRec &params)
{
  MoveFile((string(params.prjFilename)).replace(".dpr",".exe"), string(params.appFilename));
  return CG_SUCCESS;
}

extern "C" __declspec(dllexport) int buildRunProc(TBuildRunRec &params)
{
  STARTUPINFO si9;
  PROCESS_INFORMATION pi9;
  ZeroMemory(&si9, sizeof(STARTUPINFO));
  si9.cb = sizeof(STARTUPINFO);
  si9.dwFlags = STARTF_USESHOWWINDOW;
  si9.wShowWindow = SW_SHOWDEFAULT;
  CreateProcess(NULL, string(params.FileName).c_str(), NULL, NULL, false, CREATE_DEFAULT_ERROR_MODE, NULL, NULL, &si9, &pi9);
  params.data = (void *)(pi9.hProcess);
  while(WaitForSingleObject(pi9.hProcess, -1) == WAIT_TIMEOUT) {
  }
  return CG_SUCCESS;
}

extern "C" __declspec(dllexport) int buildStopProc(TBuildRunRec &params)
{
  TerminateProcess((HANDLE)((int)params.data), 0);
  return CG_SUCCESS;
}


int WINAPI DllMain(HINSTANCE hInstance, DWORD fdReason, PVOID pvReserved)
{
  return 0;
}

// made by "HiAsm 3.65 build 167"
